(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringify = exports.parse = void 0;
const util_1 = require("./src/util");
const schema_1 = require("./src/schema");
const stringify_1 = require("./src/stringify");
const parser_1 = require("./src/parser");
var schema_2 = require("./src/schema");
Object.defineProperty(exports, "parseSchema", { enumerable: true, get: function () { return schema_2.parseSchema; } });
function parse(source, schema, options = {}) {
    if (options.vars && Object.keys(options.vars).length === 0) {
        delete options.vars;
    }
    try {
        var statements = parser_1.lex(source, new util_1.Pos());
        return parser_1.parseZaml(source, new util_1.Pos(), typeof schema === 'string' ? schema_1.parseSchema(schema) : schema, statements, options);
    }
    catch (e) {
        if (e instanceof util_1.ZamlError) {
            if (e.pos && e.pos.i === 0 && e.message.match('[missing key]')) {
                // Don't add source to top-level required key errors.
            }
            else {
                e.addSource(source);
            }
        }
        throw e;
    }
}
exports.parse = parse;
function stringify(value, schema, options = {}) {
    var opts = {
        indentDepth: options.indentDepth || 0
    };
    return stringify_1.stringify(value, typeof schema === 'string' ? schema_1.parseSchema(schema) : schema, opts) + '\n';
}
exports.stringify = stringify;

},{"./src/parser":2,"./src/schema":3,"./src/stringify":4,"./src/util":5}],2:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseZaml = exports.lex = void 0;
const util_1 = require("./util");
function lex(source, pos, inBlock = false) {
    var results = [];
    while (pos.i < source.length) {
        let i = pos.i;
        let c = source[i];
        if (c === '}') {
            if (!inBlock) {
                throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
            }
            return results;
        }
        // Handle whitespace
        if (pos.skipWhitespace(source)) {
            continue;
        }
        // Comments
        if (c === '#') {
            while (pos.i < source.length && source[pos.i] !== '\n') {
                pos.newcol();
            }
            continue;
        }
        // Reserve key operators
        if (util_1.reservedOps.test(c)) {
            throw new util_1.ZamlError('syntax-error', pos, `Character ${c} is reserved for key names`);
        }
        // Whitelist errors
        if (util_1.brackets.test(c)) {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
        }
        // Special character escapes
        if (c === '\\' && source[pos.i + 1] === '$') {
            // Skip ahead one char, effectively removing the backslash from the key name.
            pos.newcol();
        }
        //
        // Begin statement
        //
        let statementPos = pos.copy();
        let name = readWord(source, pos);
        while (pos.i < source.length && pos.skipSpace(source)) { }
        let argsPosStart = pos.copy();
        //
        // Read rest of the line
        //
        let mstrs = {};
        let argsPosEnd = argsPosStart;
        while (pos.i < source.length) {
            let c2 = source[pos.i];
            if (c2 === '"' && source[pos.i + 1] === '"' && source[pos.i + 2] === '"') {
                // Read to end of multiline string
                const mstrStart = pos.copy();
                let foundClosing = false;
                pos.newcol().newcol().newcol();
                while (pos.i < source.length) {
                    let c3 = source[pos.i];
                    if (c3 === '"' && source[pos.i + 1] === '"' && source[pos.i + 2] === '"') {
                        foundClosing = true;
                        pos.newcol().newcol().newcol();
                        mstrs[mstrStart.i] = pos.copy();
                        break;
                    }
                    else {
                        pos.push(source);
                    }
                }
                if (!foundClosing) {
                    throw new util_1.ZamlError('syntax-error', mstrStart, `Unexpected EOF: Missing closing triple quotes '"""'`);
                }
            }
            else if (c2 === '\n') {
                argsPosEnd = pos.copy();
                pos.newline(source[pos.i + 1] === '\r');
                break;
            }
            else {
                pos.newcol();
            }
        }
        if (pos.i === source.length) {
            argsPosEnd = pos.copy();
        }
        let hasBlock = source[argsPosEnd.i - 1] === '{';
        let hasEmptyBlock = source[argsPosEnd.i - 2] === '{' && source[argsPosEnd.i - 1] === '}';
        if (hasBlock) {
            // Remove block bracket from args territory
            argsPosEnd.i -= 1;
            argsPosEnd.col -= 1;
        }
        else if (hasEmptyBlock) {
            // Remove block brackets from args territory
            argsPosEnd.i -= 2;
            argsPosEnd.col -= 2;
        }
        let args = source.substring(argsPosStart.i, argsPosEnd.i).replace(util_1.trailingWhitespace, '');
        let s = {
            pos: statementPos,
            type: 'pre-statement',
            name: name,
            args: args,
            mstrs,
            argsPos: [argsPosStart, argsPosEnd],
        };
        if (hasBlock) {
            s.block = lex(source, pos, true);
            if (pos.i === source.length) {
                throw new util_1.ZamlError('syntax-error', pos, `Unexpected EOF: Missing end bracket '}'`);
            }
            if (source[pos.i] !== '}') {
                throw new util_1.ZamlError('syntax-error', pos, `Expected end bracket '}', got ${JSON.stringify(source[pos.i])} instead (shouldn't be possible?)`);
            }
            pos.newcol();
        }
        else if (hasEmptyBlock) {
            s.block = [];
        }
        results.push(s);
    }
    return results;
}
exports.lex = lex;
function parseZaml(source, pos, blockSchema, statements, opts) {
    var result = blockSchema.type === 'array' ? [] : {};
    if (blockSchema.type === 'hash') {
        for (let name in blockSchema.schema) {
            if (blockSchema.schema[name].multi) {
                result[name] = [];
            }
        }
    }
    for (var i = 0; i < statements.length; i++) {
        const s = statements[i];
        let name = s.name;
        let t = blockSchema.schema[name];
        if (!t && opts.caseInsensitiveKeys) {
            var found = Object.keys(blockSchema.schema).find(n => !!n.toLowerCase().match(s.name.toLowerCase()));
            if (found && (t = blockSchema.schema[found])) {
                name = found;
            }
        }
        if (!t) {
            throw new util_1.ZamlError('user-error', s.pos, `No such config key: ${name}`);
        }
        let value = parseZamlValue(source, s, t, opts);
        if (blockSchema.type === 'array') {
            result.push([name, value]);
        }
        else if (t.multi) {
            result[name].push(value);
        }
        else {
            if (name in result) {
                throw new util_1.ZamlError('user-error', s.pos, `Duplicate key '${name}'. This key may only be specified once in this context.`);
            }
            result[name] = value;
        }
    }
    for (let name in blockSchema.schema) {
        let schema = blockSchema.schema[name];
        if (schema.req && !result.hasOwnProperty(name)) {
            var specifics = pos.i === 0 ? '' : ' in this block';
            throw new util_1.ZamlError('user-error', pos, `[missing-key] The key '${name}' is required${specifics}; please specify it.`);
        }
        else if (schema.req && schema.multi && result[name].length === 0) {
            var specifics = pos.i === 0 ? '' : ' in this block';
            throw new util_1.ZamlError('user-error', pos, `[missing-key] The key '${name}' is required${specifics}. Please specify at least one.`);
        }
    }
    return result;
}
exports.parseZaml = parseZaml;
function parseZamlValue(source, s, t, opts) {
    let parsedValue;
    if (t.type === 'num') {
        let num = Number(withVars(s.args, s.pos, opts));
        if (Number.isNaN(num)) {
            throw new util_1.ZamlError('user-error', s.argsPos[0], `Invalid number: '${s.args}'`);
        }
        parsedValue = num;
    }
    else if (t.type === 'str') {
        parsedValue = withVars(handleMultilineStr(s.args), s.pos, opts);
    }
    else if (t.type === 'enum') {
        parsedValue = withVars(s.args, s.pos, opts);
        parsedValue = parseEnumValue(parsedValue, s, t, opts);
    }
    else if (t.type === 'bool') {
        let val = withVars(s.args, s.pos, opts).toLowerCase();
        if (val === '') {
            throw new util_1.ZamlError('user-error', s.argsPos[0], `Boolean '${val} requires a value.'`);
        }
        if (val !== 'true' && val !== 'false') {
            throw new util_1.ZamlError('user-error', s.argsPos[0], `Invalid boolean: '${val}'. Value must be true or false.`);
        }
        parsedValue = val === 'true';
    }
    else if (t.type === 'list') {
        if (s.block) {
            // Block list
            if (s.args.length > 0) {
                throw new util_1.ZamlError('user-error', s.argsPos[0], listFormatError);
            }
            let list = [];
            for (let listItem of s.block) {
                //
                // Unlike the standard (configKey valuevaluevalue) format,
                // a list item is entirely a value.
                //
                // Set args to include name so that parseZamlValue will include it
                // with no additional logic.
                //
                listItem.args = `${listItem.name} ${listItem.args}`.trim();
                list.push(parseZamlValue(source, listItem, t.of, opts));
            }
            parsedValue = list;
        }
        else {
            // Inline list
            parsedValue = parseArgs(source, s.argsPos[0], s.argsPos[1], s.mstrs, opts, (arg, _k, pos) => {
                var fauxArgStatement = {
                    args: arg,
                    pos: pos,
                    name: '',
                    type: 'pre-statement',
                    mstrs: {},
                    argsPos: [pos, pos],
                };
                return parseZamlValue(source, fauxArgStatement, t.of, opts);
            });
        }
    }
    else if (t.type === 'kv') {
        var hash = {};
        if (s.block) {
            for (let s2 of s.block) {
                if (s2.args === '') {
                    throw new util_1.ZamlError('user-error', s2.argsPos[0], `Hash key '${s2.name}' requires a value.`);
                }
                hash[withVars(s2.name, s2.pos, opts)] = withVars(handleMultilineStr(s2.args), s2.argsPos[0], opts);
            }
        }
        parsedValue = hash;
    }
    else if (t.type === 'hash' || t.type === 'array') {
        if (!s.block) {
            throw new util_1.ZamlError('user-error', s.pos, `Key '${s.name}' requires a block.`);
        }
        parsedValue = parseZaml(source, s.argsPos[1], t, s.block, opts);
    }
    else if (t.type === 'tuple') {
        let args = parseArgs(source, s.argsPos[0], s.argsPos[1], s.mstrs, opts, (arg, k, pos) => {
            if (k >= t.schema.length) {
                let types = t.schema.map(t => t.type).join(' ');
                throw new util_1.ZamlError('user-error', pos, `Too many arguments; tuple only accepts ${types}`);
            }
            let t2 = t.schema[k];
            //
            // No need to transform with withVars at this point since
            // parseArgs has already done so.
            //
            if (t2.type === 'num') {
                return Number(arg);
            }
            else if (t2.type === 'str') {
                return arg;
            }
            else if (t2.type === 'bool') {
                if (arg !== 'true' && arg !== 'false') {
                    throw new util_1.ZamlError('user-error', pos, `Invalid boolean: '${arg}'. Value must be true or false.`);
                }
                return arg === 'true';
            }
            else if (t2.type === 'enum') {
                return parseEnumValue(arg, s, t2, opts);
            }
            else {
                throw new util_1.ZamlError('unexpected-error', pos, `Invalid tuple type '${JSON.stringify(t2)}' for arg '${JSON.stringify(arg)}' (Shouldn't be possible)`);
            }
        });
        if (args.length !== t.schema.length) {
            let types = t.schema.map(t => t.type).join(', ');
            throw new util_1.ZamlError('user-error', s.pos, `Incorrect number of arguments. Key '${s.name}' expects ${types}.`);
        }
        parsedValue = args;
    }
    else {
        throw new util_1.ZamlError('unexpected-error', null, `Invalid type object (${JSON.stringify(t)})`);
    }
    //
    // Handle blocks
    //
    if (util_1.BLOCKABLE_TYPES.indexOf(t.type) >= 0 && t.type !== 'list') {
        let innerBlockSchema = ('block' in t) && t.block;
        if (!innerBlockSchema) {
            if (s.block) {
                throw new util_1.ZamlError('user-error', s.argsPos[1], `Key ${s.name} does not accept a block.`);
            }
        }
        else if (!s.block) {
            if (!('req' in innerBlockSchema)) {
                //
                // A block is required if any one of its decendent's keys is required.
                // Calculate and cache.
                //
                innerBlockSchema.req = calcBlockReq(innerBlockSchema);
            }
            if (innerBlockSchema.req === true) {
                throw new util_1.ZamlError('user-error', s.pos, `Key ${s.name} requires a block.`);
            }
            else {
                //
                // Fill in an empty object for where a block would be.
                // This makes the dev's life easier by providing a consistent data structure.
                //
                parsedValue = [parsedValue, {}];
            }
        }
        else {
            parsedValue = [parsedValue, parseZaml(source, s.argsPos[1], innerBlockSchema, s.block, opts)];
        }
    }
    return parsedValue;
}
function parseEnumValue(value, s, t, opts) {
    if (opts.caseInsensitiveEnums && t.options.indexOf(value) === -1) {
        var found = t.options.find(o => !!o.toLowerCase().match(value.toLowerCase()));
        if (found) {
            value = found;
        }
    }
    if (t.options.indexOf(value) === -1) {
        throw new util_1.ZamlError('user-error', s.argsPos[0], `Invalid value: '${value}'\n  Value must be one of: ${t.options.join(', ')}`);
    }
    return value;
}
function parseQuotedString(source, pos, end) {
    var start = pos.copy();
    // TODO: Support backslash quotes
    while (pos.i < end.i && source[pos.i] !== '"') {
        if (pos.skipNewline(source)) {
            throw new util_1.ZamlError('syntax-error', pos, `Newlines are not allowed in quoted strings`);
        }
        pos.newcol();
    }
    if (pos.i === end.i) {
        throw new util_1.ZamlError('syntax-error', start, `Unexpected EOF: Missing end quote`);
    }
    var str = source.substring(start.i, pos.i);
    pos.newcol(); // Skip end quote character
    return str;
}
function parseArgs(source, start, end, mstrs, opts, map = id) {
    var args = [];
    var pos = start.copy();
    while (pos.i < end.i) {
        let c = source[pos.i];
        // Quoted string
        if (c === '"') {
            let arg = '';
            let start = pos.copy();
            let mstrEndPos = mstrs[pos.i];
            if (mstrEndPos) {
                arg = util_1.dedent(source.slice(pos.i + 3, mstrEndPos.i - 3));
                pos.goto(mstrEndPos);
            }
            else {
                arg = parseQuotedString(source, pos.newcol(), end);
            }
            args.push(map(withVars(arg, start, opts), args.length, start));
        }
        // Unquoted string
        else {
            let start = pos.copy();
            while (pos.i < end.i && source[pos.i] !== ',' && source[pos.i] !== '\n') {
                pos.newcol();
            }
            let arg = source.substring(start.i, pos.i).trim();
            args.push(map(withVars(arg, start, opts), args.length, start));
        }
        while (pos.skipSpace(source)) { }
        let c2 = source[pos.i];
        if (c2 === '\n' || c2 === '{' && source[pos.i + 1] === '\n') {
            return args;
        }
        if (c2 === ',') {
            let commaPos = pos.copy();
            pos.newcol();
            while (pos.skipSpace(source)) { }
            if (pos.i === source.length || source[pos.i] === '\n') {
                throw new util_1.ZamlError('syntax-error', commaPos, `Unexpected comma`);
            }
            continue;
        }
        if (pos.i < source.length) {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c2, ' (did you forget a comma?)'));
        }
    }
    return args;
}
function readWord(source, pos) {
    var start = pos.i;
    while (pos.i < source.length && !util_1.whitespace.test(source[pos.i])) {
        pos.newcol();
    }
    return source.substring(start, pos.i);
}
function calcBlockReq(block) {
    return Object.keys(block.schema).reduce((acc, key) => {
        if (acc)
            return acc;
        return !!block.schema[key].req;
    }, false);
}
function withVars(str, origin, opts) {
    if (!opts.vars)
        return str;
    return str.replace(/\$([a-zA-Z_][a-zA-Z0-9_]*)/g, (_match, varName) => {
        var val = opts.vars[varName];
        if (!val && opts.failOnUndefinedVars === true) {
            throw new util_1.ZamlError('user-error', origin, `Variable '$${varName}' is not defined.`);
        }
        return val || '';
    });
}
function handleMultilineStr(str) {
    return str.startsWith('"""')
        ? util_1.dedent(str.slice(3, str.length - 3))
        : str;
}
function id(x) { return x; }
const listFormatError = `You may provide a block or inline arguments to a list, but not both.
Examples:
  ✓ a_list x y z
  ✓ a_list {
      x
      y
      z
    }
`;

},{"./util":5}],3:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseSchema = void 0;
//
// Zaml schemas are deliberately non whitespace sensitive.
// The strategy to accomplish this is for each token to
// take care of their own trailing spaces.
//
const util_1 = require("./util");
function parseSchema(source) {
    try {
        var pos = new util_1.Pos();
        while (pos.skipWhitespace(source)) { }
        var startChar = source[pos.i];
        if (startChar !== '{' && startChar !== '[') {
            throw new util_1.ZamlError('syntax-error', pos, `Your schema must begin with a hash block "{" or an array block "["`);
        }
        return parseBlock(source, pos);
    }
    catch (e) {
        if (e instanceof util_1.ZamlError) {
            e.addSource(source);
        }
        throw e;
    }
}
exports.parseSchema = parseSchema;
function parseBlock(source, pos) {
    const start = pos.copy();
    const blockChar = source[pos.i];
    if (blockChar !== '{' && blockChar !== '[') {
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(blockChar, "This shouldn't happen."));
    }
    const endBlockChar = blockChar === '{' ? '}' : ']';
    const result = blockChar === '{'
        ? { type: 'hash', schema: {} }
        : { type: 'array', schema: {} };
    pos.newcol();
    while (pos.skipWhitespace(source)) { }
    while (pos.i < source.length) {
        var keyStart = pos.copy();
        var key = readKey(source, pos);
        while (pos.skipWhitespace(source)) { }
        if (key.name !== '') {
            if (result.schema[key.name]) {
                throw new util_1.ZamlError('user-error', keyStart, `Duplicate key: "${key.name}" has already been defined in this context.`);
            }
            let c = source[pos.i];
            if (c === '{' || c === '[' || c === '(') {
                throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c, '. Did you forget a colon?'));
            }
            var type = readType(source, pos, ':');
            if (key.multi)
                type.multi = true;
            if (key.req)
                type.req = true;
            result.schema[key.name] = type;
        }
        while (pos.skipWhitespace(source)) { }
        var c = source[pos.i];
        if (c === '}' || c === ']') {
            if (c !== endBlockChar) {
                throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
            }
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
            return result;
        }
        else if (c === ',') {
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
        }
        else if (pos.i < source.length) {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
        }
    }
    if (pos.i === source.length) {
        throw new util_1.ZamlError('syntax-error', start, `Missing end bracket "${endBlockChar}"`);
    }
    return result;
}
function readKey(source, pos) {
    var start = pos.i;
    while (pos.i < source.length &&
        source[pos.i] !== '{' &&
        source[pos.i] !== '}' &&
        source[pos.i] !== '[' &&
        source[pos.i] !== ']' &&
        source[pos.i] !== '(' &&
        source[pos.i] !== ')' &&
        source[pos.i] !== ',' &&
        source[pos.i] !== ':' &&
        !util_1.whitespace.test(source[pos.i])) {
        pos.newcol();
    }
    var key = source.substring(start, pos.i);
    let [name, ...attrs] = key.split('|');
    var result = { name };
    if (attrs.indexOf('multi') >= 0)
        result.multi = true;
    if (attrs.indexOf('req') >= 0)
        result.req = true;
    return result;
}
function readEnum(source, pos) {
    var start = pos.i;
    while (pos.i < source.length &&
        source[pos.i] !== '(' &&
        source[pos.i] !== ')' &&
        source[pos.i] !== ',' &&
        source[pos.i] !== ':') {
        pos.newcol();
    }
    return source.substring(start, pos.i).trim();
}
function readEnumOptions(enumTypenamePos, source, pos) {
    if (source[pos.i] !== '(') {
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i], ' (Did you forget a parenthesis?)'));
    }
    pos.newcol();
    while (pos.skipWhitespace(source)) { }
    const options = [];
    while (pos.i < source.length) {
        var option = readEnum(source, pos);
        if (option !== '') {
            options.push(option);
        }
        while (pos.skipWhitespace(source)) { }
        if (source[pos.i] === ',') {
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
        }
        else if (source[pos.i] === ')') {
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
            break;
        }
        else {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i]));
        }
    }
    if (options.length === 0) {
        throw new util_1.ZamlError('user-error', enumTypenamePos, 'An enum type must have at least one option.');
    }
    return options;
}
function readType(source, pos, targetChar) {
    const c = source[pos.i];
    if (pos.i >= source.length || c === '}' || c === ']' || c === ')' || c === ',') {
        // At this point we've reached the end without
        // a specified type. Return the default.
        return { type: 'str' };
    }
    // if (c !== nextChar && (c === '{' || c === '[' || c === '(')) {
    //   throw new ZamlError('syntax-error', pos, unexp(c, '. Did you forget a colon?'))
    // }
    if (targetChar !== null) {
        if (c !== targetChar) {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
        }
        pos.newcol(); // skip targetChar
        while (pos.skipWhitespace(source)) { }
    }
    const c2 = source[pos.i];
    if (c2 === '{' || c2 === '[') {
        return parseBlock(source, pos);
    }
    if (c2 === '(') {
        var tuplePos = pos.copy();
        pos.newcol(); // Skip open parens
        while (pos.skipWhitespace(source)) { }
        var types = readTupleTypes(source, pos, tuplePos);
        if (types.length < 2) {
            throw new util_1.ZamlError('user-error', tuplePos, `A tuple requires at least two types (${types.length ? 'onle one was' : 'none were'} provided).`);
        }
        while (pos.skipWhitespace(source)) { }
        if (source[pos.i] === '{') {
            let block = parseBlock(source, pos);
            return { type: 'tuple', schema: types, block };
        }
        else {
            return { type: 'tuple', schema: types };
        }
    }
    let typenamePos = pos.copy();
    let { name: typename } = readKey(source, pos);
    while (pos.skipWhitespace(source)) { }
    if (util_1.validTypes.indexOf(typename) === -1) {
        throw new util_1.ZamlError('user-error', typenamePos, `No such type: '${typename}'`);
    }
    if (typename === 'enum') {
        const options = readEnumOptions(typenamePos, source, pos);
        if (source[pos.i] === '{' || source[pos.i] === '[') {
            let block = parseBlock(source, pos);
            return { type: typename, options, block };
        }
        else {
            return { type: typename, options };
        }
    }
    else if (typename === 'list') {
        if (source[pos.i] !== '(') {
            //
            // A list type without parenthesis is implicitly a list of str
            //
            return { type: 'list', of: { type: 'str' } };
        }
        pos.newcol();
        while (pos.skipWhitespace(source)) { }
        let ofTypePos = pos.copy();
        let ofType = readType(source, pos, null);
        if (util_1.LISTABLE_TYPES.indexOf(ofType.type) === -1) {
            throw new util_1.ZamlError('user-error', ofTypePos, `A '${ofType.type}' type may not be within a list.`);
        }
        if (source[pos.i] !== ')') {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i]));
        }
        pos.newcol();
        while (pos.skipWhitespace(source)) { }
        return { type: 'list', of: ofType };
    }
    let c3 = source[pos.i];
    if (c3 === '{' || c3 === '[') {
        if (util_1.BLOCKABLE_TYPES.indexOf(typename) === -1) {
            throw new util_1.ZamlError('user-error', pos, `A '${typename}' type may not have a block.`);
        }
        else {
            let block = parseBlock(source, pos);
            return { type: typename, block };
        }
    }
    else if (c3 === ',' || c3 === '}' || c3 === ')' || c3 === ']' || pos.i === source.length) {
        return { type: typename };
    }
    throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i]));
}
function readTupleTypes(source, pos, openParenPos) {
    var types = [];
    while (pos.i < source.length) {
        let c = source[pos.i];
        if (c === ':' || c === '(') {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
        }
        let namePos = pos.copy();
        let { name } = readKey(source, pos);
        while (pos.skipWhitespace(source)) { }
        if (name === 'enum') {
            const options = readEnumOptions(namePos, source, pos);
            types.push({ type: 'enum', options });
        }
        else if (name !== '') {
            let type = util_1.basicTypeFromName(name);
            if (!type) {
                throw new util_1.ZamlError('user-error', namePos, `Invalid tuple type '${name}'. Tuples may only contain str, num, bool, and enums.`);
            }
            types.push(type);
        }
        let c2 = source[pos.i];
        if (c2 === ',') {
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
            continue;
        }
        if (c2 === ')') {
            pos.newcol();
            return types;
        }
        if (c2 === '{') {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c2, ' (blocks are not allowed within a tuple type)'));
        }
        var hint = c2.match(/[a-z0-9]/i) ? ' (did you forget a comma?)' : '';
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c2, hint));
    }
    throw new util_1.ZamlError('syntax-error', openParenPos, `Missing end parenthesis ")"`);
}

},{"./util":5}],4:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringify = void 0;
function stringify(data, blockSchema, opts) {
    const parts = [];
    const seenMulti = {};
    const ind = indentation(opts.indentDepth);
    let dataQueue = blockSchema.type === 'hash'
        ? Object.keys(blockSchema.schema).map(configKey => [configKey, data[configKey]])
        : data;
    while (dataQueue.length) {
        let [key, _value] = dataQueue.shift();
        if (_value === undefined)
            continue;
        let t = blockSchema.schema[key];
        if (t.multi && !seenMulti[key]) {
            seenMulti[key] = true;
            dataQueue = _value.map((v) => [key, v]).concat(dataQueue);
            continue;
        }
        let valueParts = stringifyValue(_value, t, opts);
        valueParts[0] = `${ind}${key} ${valueParts[0]}`;
        parts.push(...valueParts);
    }
    return parts.join('\n');
}
exports.stringify = stringify;
function stringifyValue(_value, t, opts) {
    const parts = [];
    const ind = indentation(opts.indentDepth);
    const [value, block] = ('block' in t)
        ? _value
        : [_value, null];
    if (t.type === 'num' ||
        t.type === 'str' ||
        t.type === 'bool' ||
        t.type === 'enum') {
        parts.push(value);
    }
    else if (t.type === 'list') {
        parts.push('{');
        if (Array.isArray(value)) {
            //
            // Clear out indentation since we will add it ourselves
            //
            let opts2 = Object.assign(Object.assign({}, opts), { indentDepth: 0 });
            let list_ind = indentation(opts.indentDepth + 1);
            for (let item of value) {
                parts.push(...stringifyValue(item, t.of, opts2).map(line => `${list_ind}${line}`));
            }
        }
        parts.push(ind + '}');
    }
    else if (t.type === 'kv') {
        let ind_2 = indentation(opts.indentDepth + 1);
        parts.push(`{`);
        for (let key in value) {
            parts.push(ind_2 + `${key} ${value[key]}`);
        }
        parts.push(ind + '}');
    }
    else if (t.type === 'tuple') {
        parts.push(value.join(', '));
    }
    else if (t.type === 'hash' || t.type === 'array') {
        parts.push('{');
        parts.push(stringify(value, t, indent(1, opts)));
        parts.push(ind + '}');
    }
    if ('block' in t && t.block && block) {
        addBlockBracket(parts);
        parts.push(stringify(block, t.block, indent(1, opts)));
        parts.push(ind + '}');
    }
    return parts;
}
function indentation(n) {
    let result = '';
    for (let i = 0; i < n; i++) {
        result += '  ';
    }
    return result;
}
function indent(mod, opts) {
    return Object.assign(Object.assign({}, opts), { indentDepth: opts.indentDepth + mod });
}
function addBlockBracket(parts) {
    parts[parts.length - 1] = parts[parts.length - 1] + ' {';
}

},{}],5:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pos = exports.dedent = exports.unexp = exports.isObj = exports.ZamlError = exports.basicTypeFromName = exports.BLOCKABLE_TYPES = exports.LISTABLE_TYPES = exports.validTypes = exports.trailingWhitespace = exports.reservedOps = exports.whitespace = exports.brackets = void 0;
//
// Constants
//
exports.brackets = /[\(\)\{\}\[\]]/;
exports.whitespace = /[ \t\n\r]/;
exports.reservedOps = /[\^&#@~`]/;
exports.trailingWhitespace = /[ \t\n\r]*$/;
exports.validTypes = ['num', 'str', 'kv', 'list', 'bool', 'enum'];
exports.LISTABLE_TYPES = ['str', 'num', 'enum'];
exports.BLOCKABLE_TYPES = ['str', 'num', 'bool', 'tuple'];
function basicTypeFromName(name) {
    if (name === 'num' || name === 'str' || name === 'bool') {
        return { type: name };
    }
    return null;
}
exports.basicTypeFromName = basicTypeFromName;
class ZamlError extends Error {
    constructor(type, pos, message) {
        super(`[ZamlError] ${message}`);
        this.type = type;
        this.pos = pos;
    }
    static syntax(pos, char, more = '') {
        return new ZamlError('syntax-error', pos, `Unexpected '${char}'${more}`);
    }
    addSource(source) {
        if (!this.pos)
            return;
        var lines = source.split('\n');
        var { line, col } = this.pos;
        var lineNo = String(line);
        var prevLineNo = String(line - 1);
        if (lineNo.length > prevLineNo.length) {
            prevLineNo = spacer(lineNo.length - prevLineNo.length) + prevLineNo;
        }
        else if (prevLineNo.length > lineNo.length) {
            lineNo = spacer(prevLineNo.length - lineNo.length) + lineNo;
        }
        this.message =
            this.message + '\n' +
                `  on line ${line} col ${col}\n\n` +
                (line > 1 ? `  ${prevLineNo}│ ${lines[line - 2]}\n` : '') +
                `  ${lineNo}│ ${lines[line - 1]}\n  ${spacer(col - 1 + lineNo.length + 2)}^`;
    }
}
exports.ZamlError = ZamlError;
//
// Helpers
//
function isObj(x) {
    return Object.prototype.toString.call(x) === '[object Object]';
}
exports.isObj = isObj;
function unexp(char, more = '') {
    return `Unexpected ${JSON.stringify(char)}${more}`;
}
exports.unexp = unexp;
function range(start, end) {
    var result = [];
    for (var i = start; i < end; i++)
        result.push(i);
    return result;
}
function spacer(length) {
    return range(0, length).map(_ => ' ').join('');
}
// Taken and modified from https://github.com/dmnd/dedent
function dedent(string) {
    const lines = string.split("\n");
    let mindent = 0;
    lines.forEach(l => {
        let m = l.match(/^(\s+)\S+/);
        if (m) {
            let indent = m[1].length;
            if (!mindent) {
                // this is the first indented line
                mindent = indent;
            }
            else {
                mindent = Math.min(mindent, indent);
            }
        }
    });
    let result = '';
    if (mindent !== null) {
        const m = mindent; // appease TS
        result = lines.map(l => l[0] === " " ? l.slice(m) : l).join("\n");
    }
    return result
        // dedent eats leading and trailing whitespace too
        .trim()
        // handle escaped newlines at the end to ensure they don't get stripped too
        .replace(/\\n/g, "\n");
}
exports.dedent = dedent;
class Pos {
    constructor(line = 1, col = 1, i = 0) {
        this.line = line;
        this.col = col;
        this.i = i;
    }
    push(source) {
        this.skipNewline(source) || this.newcol();
        return this;
    }
    newcol() {
        this.i += 1;
        this.col += 1;
        return this;
    }
    newline(windowsLine = false) {
        this.i += (windowsLine ? 2 : 1);
        this.col = 1;
        this.line += 1;
    }
    copy() {
        return new Pos(this.line, this.col, this.i);
    }
    goto(target) {
        this.i = target.i;
        this.col = target.col;
        this.line = target.line;
    }
    skipSpace(source) {
        if (source[this.i] === ' ' || source[this.i] === '\t') {
            this.newcol();
            return true;
        }
        return false;
    }
    skipNewline(source) {
        if (source[this.i] === '\n') {
            this.newline(source[this.i + 1] === '\r');
            return true;
        }
        return false;
    }
    skipWhitespace(source) {
        if (this.i >= source.length)
            return false;
        return this.skipSpace(source) || this.skipNewline(source);
    }
}
exports.Pos = Pos;

},{}],6:[function(require,module,exports){
window.Zaml = require('./dist/index.js')

},{"./dist/index.js":1}]},{},[6]);
